/**********************************************************************
 *<
	FILE: FloatSpringController.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#include "FloatSpringController.h"




static FloatSpringControllerClassDesc FloatSpringControllerDesc;
ClassDesc2* GetFloatSpringControllerDesc() { return &FloatSpringControllerDesc; }




static ParamBlockDesc2 floatspringcontroller_param_blk ( floatspringcontroller_params, _T("params"),  0, &FloatSpringControllerDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
	// params
	pb_mass, 			_T("mass"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_MASS, 
		p_default, 		1.0f, 
		p_range, 		0.0f,1000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_MASS,	IDC_MASSSPIN, 0.01f, 
		end,
	pb_strength, 			_T("strength"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_STRENGTH, 
		p_default, 		0.1f, 
		p_range, 		0.0f,1000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_STRENGTH,	IDC_STRENGTHSPIN, 0.01f, 
		end,
	pb_dampening, 			_T("dampening"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_DAMPENING, 
		p_default, 		0.1f, 
		p_range, 		0.0f,1000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_DAMPENING,	IDC_DAMPENINGSPIN, 0.01f, 
		end,

	pb_samples, 			_T("samples"), 		TYPE_FLOAT, 	0, 	IDS_SAMPLES, 
		p_default, 		2.0f, 
		p_range, 		0.01f,1000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_SAMPLE,	IDC_SAMPLESPIN, 0.01f, 
		end,

	pb_driver, 			_T("driver"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_DRIVER, 
		p_default, 		0.1f, 
		p_range, 		-100000.0f, 100000.0f, 
		end,

	pb_cache, 			_T("cache"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_CACHE, 
		p_default, 		0.0f, 
		p_range, 		-100000.0f, 100000.0f, 
		end,

	pb_enable, _T("enableSpringMotion"),	TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_ENABLE,
		p_default, 		TRUE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_SPRINGMOTION_CHECK, 
		end,

	pb_manualsolve, _T("manualSolve"),	TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_MANUAL,
		p_default, 		FALSE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_MANUALSOLVECHECK, 
		end,

	end
	);


BOOL FloatSpringControlDlgProc::DlgProc(TimeValue t, IParamMap2 *map, HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{

	switch (msg) 
		{
		case WM_INITDIALOG:
			{
			cont->hWnd = hWnd;

			break;
			}
		case CC_SPINNER_CHANGE:
			cont->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
			break;
		case WM_COMMAND:
			{

			if (LOWORD(wParam) == IDC_OKBUTTON)
				{
				cont->activeDialog = FALSE;
				DestroyModelessParamMap2(cont->pDialogMap);
				
				}
			else if (LOWORD(wParam) == IDC_ABOUT)
				{
				ShellExecute(GetCOREInterface()->GetMAXHWnd(), "open", "iexplore.exe", "www.max3dstuff.com/max5/floatspring/help.html", NULL, SW_SHOWNORMAL);
				}
			else if (LOWORD(wParam) == IDC_SOLVE)
				{
				cont->RebuildCache();
				cont->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
				GetCOREInterface()->RedrawViews(GetCOREInterface()->GetTime());
				}
			else
				{
				cont->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
				GetCOREInterface()->RedrawViews(GetCOREInterface()->GetTime());
				}
			break;
			}
		}
			
	return FALSE;
}



class RangeRestore : public RestoreObj {
	public:
		FloatSpringController *cont;
		Interval ur, rr;
		RangeRestore(FloatSpringController *c) 
			{
			cont = c;
			ur   = cont->range;
			}   		
		void Restore(int isUndo) 
			{
			rr = cont->range;
			cont->range = ur;
			cont->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
			}
		void Redo()
			{
			cont->range = rr;
			cont->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
			}		
		void EndHold() 
			{ 
			cont->ClearAFlag(A_HELD);
			}
		TSTR Description() { return TSTR(_T("Noise control range")); }
	};


	// make the paramblock
FloatSpringController::FloatSpringController()
	{
	FloatSpringControllerDesc.MakeAutoParamBlocks(this);
	pDialogMap = NULL;
	proc = NULL;
	activeDialog = FALSE;
	stopRef = FALSE;
	rebuildCache = FALSE;


	}

FloatSpringController::~FloatSpringController()
	{
	if (activeDialog) 
		{

		DestroyModelessParamMap2(pDialogMap);
		}
	DeleteAllRefsFromMe();
	}


void FloatSpringController::HoldRange()
	{
	if (theHold.Holding() && !TestAFlag(A_HELD)) {
		SetAFlag(A_HELD);
		theHold.Put(new RangeRestore(this));
		}
	}

void FloatSpringController::EditTimeRange(Interval range,DWORD flags)
	{
	if (!(flags&EDITRANGE_LINKTOKEYS)) {
		HoldRange();
		this->range = range;
		NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
		}
	}

void FloatSpringController::MapKeys(TimeMap *map,DWORD flags)
	{
	if (flags&TRACK_MAPRANGE) {
		HoldRange();
		TimeValue t0 = map->map(range.Start());
		TimeValue t1 = map->map(range.End());
		range.Set(t0,t1);
		NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
		}
	}

RefTargetHandle FloatSpringController::Clone(RemapDir& remap)
	{
	// make a new noise controller and give it our param values.
	FloatSpringController *cont = new FloatSpringController;
	cont->ReplaceReference(PBLOCK_REF, pblock->Clone(remap));
	// Clone the strength controller
	CloneControl(cont,remap);
	BaseClone(this, cont, remap);
	return cont;
	}

void FloatSpringController::Copy(Control *from)
{
	pblock->SetController(pb_driver,0,from);;
}


void FloatSpringController::RebuildCache()
{
	float mass, strength, dampening,goal;
	
	int sampleRate = 1;
	pblock->GetValue(pb_samples,0,sampleRate,FOREVER);
	int tpf = GetTicksPerFrame()/sampleRate;
//get start and end time range
//iterate through frames
	float vel=0.0f;
	float f = 0.0f;

	if (range == NEVER)
		{	
		range.Set(GetCOREInterface()->GetAnimRange().Start(),GetCOREInterface()->GetAnimRange().End());
		}

	pblock->GetValue(pb_driver,range.Start(),f,FOREVER);

	stopRef = TRUE;

	int animating =  Animating();


	Control *cont = NULL;
	cont = pblock->GetController(pb_cache,0);
	if (cont)
		{
		IKeyControl *ikc = GetKeyControlInterface(cont);
		if (ikc) ikc->SetNumKeys(0);
		}

	AnimateOn();


	for (int i = range.Start(); i < range.End(); i += tpf)
		{
//get mass, dampening and strength
		pblock->GetValue(pb_mass,i,mass,FOREVER);
		pblock->GetValue(pb_strength,i,strength,FOREVER);
		pblock->GetValue(pb_dampening,i,dampening,FOREVER);

		pblock->GetValue(pb_driver,i,goal,FOREVER);

//compute vel and new pos
		
//set it back
		float force = (goal-f);
		vel += ((strength*force)-(dampening*vel))*mass;
		f += vel;
		pblock->SetValue(pb_cache,i,f);

		}



	if (!animating)
		AnimateOff();

	stopRef = FALSE;
}

void FloatSpringController::SetValueLocalTime(TimeValue t, void *val, int commit, GetSetMethod method)
	{
	float f = *((float*)val);
	pblock->SetValue(pb_driver,t,f);
//rebuild the cache
	BOOL manual;
	pblock->GetValue(pb_manualsolve,t,manual,FOREVER);
	if (!manual)
		RebuildCache();

	}

void FloatSpringController::GetValueLocalTime(
		TimeValue t, void *val, Interval &valid, GetSetMethod method)
	{

	BOOL manual;
	pblock->GetValue(pb_manualsolve,t,manual,FOREVER);

	BOOL enable;
	pblock->GetValue(pb_enable,t,enable,FOREVER);

	if ((rebuildCache) && (!manual))
		RebuildCache();
	rebuildCache = FALSE;
// This controller is always changing.
	valid.SetInstant(t);

	float f;
	if (enable)
		pblock->GetValue(pb_cache,t,f,FOREVER);
	else pblock->GetValue(pb_driver,t,f,FOREVER);
//get target node
	*((float*)val) = f;
	}

void FloatSpringController::Extrapolate(	Interval range,TimeValue t,void *val,Interval &valid,int type)
	{
	float val0, val1, val2, res;
	switch (type) {
		case ORT_LINEAR:			
			if (t<range.Start()) {
				GetValueLocalTime(range.Start(),&val0,valid);
				GetValueLocalTime(range.Start()+1,&val1,valid);
				res = LinearExtrapolate(range.Start(),t,val0,val1,val0);				
			} else {
				GetValueLocalTime(range.End()-1,&val0,valid);
				GetValueLocalTime(range.End(),&val1,valid);
				res = LinearExtrapolate(range.End(),t,val0,val1,val1);
				}
			break;

		case ORT_IDENTITY:
			if (t<range.Start()) {
				GetValueLocalTime(range.Start(),&val0,valid);
				res = IdentityExtrapolate(range.Start(),t,val0);
			} else {
				GetValueLocalTime(range.End(),&val0,valid);
				res = IdentityExtrapolate(range.End(),t,val0);
				}
			break;

		case ORT_RELATIVE_REPEAT:
			GetValueLocalTime(range.Start(),&val0,valid);
			GetValueLocalTime(range.End(),&val1,valid);
			GetValueLocalTime(CycleTime(range,t),&val2,valid);
			res = RepeatExtrapolate(range,t,val0,val1,val2);			
			break;
		}
	valid.Set(t,t);
	*((float*)val) = res;
	}


RefResult FloatSpringController::NotifyRefChanged(
		Interval iv,  
		RefTargetHandle hTarg, 
		PartID& partID, 
		RefMessage msg) 
	{
	if (stopRef) return REF_STOP;

	switch (msg) {
		case REFMSG_CHANGE:

			if (hTarg == pblock)
				{
				ParamID changing_param = pblock->LastNotifyParamID();
				floatspringcontroller_param_blk.InvalidateUI(changing_param);
				if (activeDialog)
					{
					UpdateWindow(hWnd);
					}	
				rebuildCache = TRUE;

				}
		break;

		case REFMSG_OBJECT_CACHE_DUMPED:
			
			return REF_STOP;

		break;
		}
	return REF_SUCCEED;
	}
IOResult FloatSpringController::Save(ISave *isave)
	{
	return IO_OK;
	}	
IOResult FloatSpringController::Load(ILoad *iload)
	{
	ULONG nb = 0;
	IOResult res = IO_OK;
	return IO_OK;
	}

void FloatSpringController::EditTrackParams(
		TimeValue t,
		ParamDimensionBase *dim,
		TCHAR *pname,
		HWND hParent,
		IObjParam *ip,
		DWORD flags)
	{

	if (!activeDialog) 
		{
		activeDialog = TRUE;
		FloatSpringControlDlgProc *proc = new FloatSpringControlDlgProc();
		proc->SetThing(this);
		pDialogMap = CreateModelessParamMap2 (
			floatspringcontroller_params, pblock, t, hInstance, MAKEINTRESOURCE (IDD_PANEL),
			GetCOREInterface()->GetMAXHWnd(), proc);
		}
	}

